"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _transpileLess = _interopRequireDefault(require("./transpileLess"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _default = function _default(source, state) {
  var result = source;
  var cursor;
  var sq = 0;
  var tplDict = {};
  var topLevelDict = {};

  while ((cursor = result.indexOf('${')) > -1) {
    var start = cursor;
    cursor += 1;
    var close = start;
    var stack = 1;

    while (stack > 0) {
      close = result.indexOf('}', cursor + 1);
      if (close === -1) throw 'template brace not balanced';
      var open = result.indexOf('{', cursor + 1);

      if (open === -1 || open > close) {
        cursor = close;
        stack -= 1;
      } else {
        cursor = open;
        stack += 1;
      }
    }

    var tpl = result.slice(start, close + 1);
    var key = "var(--LESS-FOR-STYLED-".concat(sq++, ")");
    tplDict[key] = tpl;
    result = result.replace(tpl, key);
  }

  cursor = 0;
  var topLevelStyleAndSelectorEnd;
  var startStack = 1;

  while ((topLevelStyleAndSelectorEnd = result.indexOf('{', cursor)) > 1) {
    var topLevelStyleAndSelector = result.substring(cursor, topLevelStyleAndSelectorEnd);
    var _start = cursor;
    cursor = topLevelStyleAndSelectorEnd;

    var _close = void 0;

    var _stack = startStack;

    while (_stack > 0) {
      _close = result.indexOf('}', cursor + 1);
      if (_close === -1) throw 'style brace not balanced';

      var _open = result.indexOf('{', cursor + 1);

      if (_open === -1 || _open > _close) {
        cursor = _close + 1;
        _stack -= 1;
      } else {
        cursor = _open;
        _stack += 1;
      }
    }

    var selectorIndex = topLevelStyleAndSelector.lastIndexOf(';') + 1;
    var selector = topLevelStyleAndSelector.substring(selectorIndex);

    if (selector.trim().startsWith('@media')) {
      var nextOpen = result.indexOf('{', topLevelStyleAndSelectorEnd + 2);
      var nextClose = result.indexOf('}', topLevelStyleAndSelectorEnd + 2);

      if (nextOpen !== -1 && nextOpen < nextClose) {
        // next block is contained by media query
        cursor = topLevelStyleAndSelectorEnd + 2;
        startStack = 2;
      }
    } else {
      startStack = 1;

      if (selector.includes('&')) {
        var _key = ".--LESS-FOR-STYLED-".concat(sq++);

        topLevelDict[_key] = selector.trim();
        cursor += _key.length - selector.length;
        result = result.substring(0, _start + selectorIndex) + _key + result.substring(_start + selectorIndex + selector.length);
      }
    }
  }

  if (Array.isArray(state.opts.globalImports)) {
    result = state.opts.globalImports.map(function (f) {
      return "@import \"".concat(f, "\";");
    }).join('') + result;
  }

  try {
    var transpiled = (0, _transpileLess["default"])(result, state.file.opts.filename, state.opts);
    Object.keys(topLevelDict).forEach(function (k) {
      return transpiled = transpiled.replaceAll(k, topLevelDict[k]);
    });
    Object.keys(tplDict).forEach(function (k) {
      return transpiled = transpiled.replaceAll(k, tplDict[k]);
    });
    return transpiled;
  } catch (e) {
    console.error("Error converting the less syntax for the file:", state.file.opts.filename, source, e);
  }
};

exports["default"] = _default;